/***************************************************************************
                          board.cpp  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 1999                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca                                     
 ***************************************************************************/
/***************************************************************************
  The original vergion of Kvirus is Ataxxlet written in JAVA
    by Paul Buchheit <ptb@po.cwru.edu>
  Kvirus is KDE port of Ataxxlet.
****************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "board.h"

Board::Board(){
  initBoard();
}
Board::~Board(){
}

void Board::initBoard(){
  blockId=3;
  openId=0;
  for(int k=0;k<9; k++)
    for(int l;l<9;l++){
      this->board[k][l]=0;
    }
}

void Board::setSpot(int x, int y, int player){
  board[x][y]=player;
}



int Board::getSpot(int x, int y){
  return(this->board[x][y]);
}

int Board::isLegalMove(Move *m, int player){
  if(!isOpen(m->gettoX(),m->gettoY())|| !isOnBoard(m->getfromX(),m->getfromY()) ||(getSpot(m->getfromX(),m->getfromY()) !=player))
    return (0);
  else if(abs(m->getfromX()-m->gettoX()) < 3 && (abs(m->getfromY()-m->gettoY())<3))
    return(1);
  else
    return(0);
}

int Board::isGameOver(){
  return(1);
}

int Board::isOnBoard(int x, int y){
  if((x>=0)&&(y>=0)&&(x<9)&&(y<9))
    return(1);
  else
    return(0);
}

int Board::isOpen(int x, int y){
  if(isOnBoard(x, y) &&(getSpot(x, y)==0))
    return(1);
  else
    return(0);
}

int Board::isBlock(int x, int y){

  if(isOnBoard(x, y) &&(getSpot(x, y)==3))
    return(1);
  else
    return(0);

}


int Board::isEnemy(int player, int x, int y){
    if((getSpot(x, y)!=player)&&(getSpot(x, y)!=openId)&&(getSpot(x, y)!=blockId))
    return(1);
  else
    return(0);
}

int Board::isGoingToWall(Move *m){
  if((m->gettoX()==0)||(m->gettoY()==0)||(m->gettoX()==8)||(m->gettoY()==8))
    return(1);
  else
    return(0);
}

int Board::advanceMove(Move *m, int player){
  int i=m->gettoX()-m->getfromX();
  int j=m->gettoY()-m->getfromY()+1;

  if(j>2){
    j=-2;
    i++;
    if(i>2){
      i=-2;
      do{
        m->setfromY(m->getfromY()+1);
        if(m->getfromY()>=9){
          m->setfromY(0);
          m->setfromX(m->getfromX()+1);
          if(m->getfromX()>=9)
            return(0);
        }
      }while(this->getSpot(m->getfromX(),m->getfromY())!=player);
    }
  }
  m->settoX(m->getfromX()+i);
  m->settoY(m->getfromY()+j);
  return(1);

}

int Board::possibleMoveExists(int player){
  Move *m = new Move();
  m->setfromX(0);
  m->setfromY(0);
  m->settoX(0);
  m->settoY(0);
  return(advanceLegalMove(m, player));
}

int Board::advanceLegalMove(Move *m, int player){
  while(advanceMove(m, player))
    if(isLegalMove(m, player))
      return(1);
  return(0);
}



































