/***************************************************************************
                          kvirusview.cpp  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 00:50:22 PDT 1999
                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : sskang@po-box.mcgill.ca                                     
 ***************************************************************************/
/***************************************************************************
  The original vergion of Kvirus is Ataxxlet written in JAVA
    by Paul Buchheit <ptb@po.cwru.edu>
  Kvirus is KDE port of Ataxxlet.
****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
 #include <stdio.h>
 #include <stdlib.h>
 #include <unistd.h>

#include <kvirusview.h>

QString icondir = KApplication::kde_datadir()+"/kvirus/pics/";

KvirusView::KvirusView(KApplication* a,KvirusDoc* doc,QWidget *parent)
	: QWidget(parent){
	
	b = new Board();
  human= new Player(b,1);
  computer=new Player(b,2);
  initBoard();
  timer = new QTimer(this);
  connect( timer, SIGNAL(timeout()), SLOT(computerMove()) );

  this->resize(300, 350);

}

KvirusView::~KvirusView(){
}


///////////////////////////
void KvirusView::drawCircle(int i, int j, QPixmap pix){
  QPainter p;
  QPoint point(hole_begin+i*small_width, j*small_width_y);
  p.begin(this);
  p.drawPixmap(point, pix);
  p.end();
}

void KvirusView::mousePressEvent(QMouseEvent *point){
  QPixmap rpix;
  QPixmap rspix;
  int x, y;
  x=point->x()/small_width;
  y=point->y()/small_width_y;
  if(isHumanTurn()){
    if(!isClicked() && !b->isEnemy(1, x, y) && !b->isOpen(x, y) &&!b->isBlock(x, y)){
      setClicked(1);
      human->m->setfromX(x);
      human->m->setfromY(y);
      if(!rspix.load(icondir+"/virus_r_s.xpm"))
        rspix.load("virus_r_s.xpm");
      drawCircle(x, y, rspix);
    }
    else if (isClicked()){
      if((human->m->getfromX()==x) && (human->m->getfromY()==y)){
        setClicked(0);
        if(!rpix.load(icondir+"/virus_r.xpm"))
          rpix.load("virus_r.xpm");
        drawCircle(x,y, rpix);
      }
      else{
        human->m->settoX(x);
        human->m->settoY(y);
        playerMove(human);
        timer->start(200, TRUE);
      }
    }
  }
}


void KvirusView::paintEvent(QPaintEvent *){
  QPainter p;
  QPixmap rpix;
  QPixmap bpix;
  QPixmap gpix;
  QPixmap blpix;
  p.begin(this);
  p.fillRect(0, 0, window_width, window_height, gray);
  p.end();
  if(!gpix.load(icondir+"/virus_gray.xpm"))
    gpix.load("virus_gray.xpm");
  if(!rpix.load(icondir+"/virus_r.xpm"))
    rpix.load("virus_r.xpm");
  if(!bpix.load(icondir+"/virus_b.xpm"))
    bpix.load("virus_b.xpm");
  if(!blpix.load(icondir+"/block.xpm"))
    blpix.load("block.xpm");
  for(int i=0;i<9; i++)
    for(int j=0;j<9;j++){
      drawCircle(i, j, gpix);
    }
  for(int i=0; i<9; i++){
    for(int j=0; j<9; j++){
      if(b->getSpot(i, j) != 0){
        if(b->getSpot(i, j)==1)
          drawCircle(i, j, rpix);
        else if(b->getSpot(i, j)==2)
          drawCircle(i, j, bpix);
        else if(b->getSpot(i, j)==3)
          drawCircle(i, j, blpix);
      }
    }
  }
}

void KvirusView::initBoard(){
  setGameFlag(1);
  setHumanTurn(1);
  setClicked(0);
  setBlockFlag(1);
  window_width=300;
  window_height=400;
  small_width=int(window_width/9);
  small_width_y=int((window_height)/9);
  stone_width=int(.99*small_width);
  stone_height=int(.99*small_width_y);
  hole_begin=int((small_width-stone_width)/2);


  b->setSpot(0,0, 1);
  b->setSpot(8,8, 1);
  b->setSpot(8,0, 2);
  b->setSpot(0,8, 2);

  if(isBlockFlag()){
    b->setSpot(3,3, 3);
    b->setSpot(5,5, 3);
    b->setSpot(6,2, 3);
    b->setSpot(2,6, 3);
  }

}

void KvirusView::resizeEvent(QResizeEvent *r){
  QSize s= r->size();
  window_width=s.width();
  window_height=s.height();
  small_width=int(this->width()/9);
  small_width_y=int((this->height())/9);
  stone_width=int(.99*small_width);
  stone_height=int(.99*small_width_y);
  hole_begin=int((small_width-stone_width)/2);
}

void KvirusView::drawPix(int x, int y, int val){
  QPixmap rpix;
  QPixmap bpix;
  QPixmap gpix;
  QPixmap rspix;

  if(!gpix.load(icondir+"/virus_gray.xpm"))
    gpix.load("virus_gray.xpm");
  if(!rpix.load(icondir+"/virus_r.xpm"))
    rpix.load("virus_r.xpm");
  if(!rspix.load(icondir+"/virus_r_s.xpm"));
    rspix.load("virus_r_s.xpm");
  if(!bpix.load(icondir+"/virus_b.xpm"))
    bpix.load("virus_b.xpm");

  if(val==0)
      drawCircle(x, y, gpix);
  else if(val ==2)
      drawCircle(x, y, rpix);
  else if(val ==3)
      drawCircle(x, y, bpix);
  else if(val ==4)
      drawCircle(x, y, rspix);
}

void KvirusView::eat_enemy(Player *pl){
  QPixmap pix;
  QPixmap gpix;

  int i, j;

  if(pl->m->distance() > 1){
    b->setSpot(pl->m->getfromX(),pl->m->getfromY(),0);
    if(!gpix.load(icondir+"/virus_gray.xpm"))
      gpix.load("virus_gray.xpm");
    drawCircle(pl->m->getfromX(),pl->m->getfromY(), gpix);
  }
  if(pl->player==1){
    if(!pix.load(icondir+"/virus_r.xpm"))
      pix.load("virus_r.xpm");
  }
  else if(pl->player==2){
    if(!pix.load(icondir+"/virus_b.xpm"))
      pix.load("virus_b.xpm");
  }
  for(i=-1;i<=1;i++)
    for(j=-1;j<=1;j++){
      if(b->isOnBoard(pl->m->gettoX()+i,pl->m->gettoY()+j) && b->isEnemy(pl->player, pl->m->gettoX()+i,pl->m->gettoY()+j)){
        b->setSpot(pl->m->gettoX()+i,pl->m->gettoY()+j,pl->player);
        drawCircle(pl->m->gettoX()+i,pl->m->gettoY()+j, pix);
      }
    }
}


void KvirusView::score_report(){
  int i, x, y;
  int score[2];
  char result[80];
  char msg[80];
  for(i=0;i<2;i++)
    score[i]=0;
  for(x=0;x<9;x++)
    for(y=0;y<9;y++){

      if((b->getSpot(x, y) > 0) && (b->getSpot(x, y) < 3))
        score[b->getSpot(x, y)-1]+=1;
    }
  if(score[0]>score[1])
    sprintf(msg,"AAAAAArg... You beat me!\n\n");
  else
    sprintf(msg, "HeHeHe... You Lost.. I got ya!!\n\n");
  sprintf(result,"Your Score is %d and My Score is %d", score[0], score[1]);
  strncat(msg, result, 40);
  KMsgBox::message(this, "Game Over", msg, 0,0);
}

void KvirusView::computerMove(){
  if(!isHumanTurn()){
    computer->m->resetMove();
    do{
        if(b->possibleMoveExists(2)){
          computer->m=computer->findBestMove();
        if(playerMove(computer))
          continue;
        }
        else if(!b->possibleMoveExists(1)){
          score_report();
          setGameFlag(0);
          break;
        }
    }while(!b->possibleMoveExists(1));
  }
  setHumanTurn(1);
}

bool KvirusView::playerMove(Player *pl){
  QPixmap rspix;
  QPixmap rpix;
  QPixmap bpix;
  int index;
  if(b->isLegalMove(pl->m, pl->getplayer())){
    if(pl->getplayer()==1){
      index = 1;
      b->setSpot(pl->m->gettoX(), pl->m->gettoY(), 1);
      if(!rpix.load(icondir+"/virus_r.xpm"))
        rpix.load("virus_r.xpm");
      drawCircle(pl->m->getfromX(), pl->m->getfromY(), rpix);
      drawCircle(pl->m->gettoX(),pl->m->gettoY(), rpix);
      setClicked(0);
      setHumanTurn(0);
    }
    else if(pl->getplayer()==2){
      index=2;
      if(!bpix.load(icondir+"/virus_b.xpm"))
        bpix.load("virus_b.xpm");
      b->setSpot(pl->m->gettoX(), pl->m->gettoY(), 2);
      drawCircle(pl->m->gettoX(),pl->m->gettoY(), bpix);
    }

    eat_enemy(pl);
    return(1);
  }
  else{
    if(pl->getplayer()==1){
      setClicked(0);
      KMsgBox::message(this, "Wrong Move", "Illegal Move\n", 0, 0);
      return(0);
    }
    else if(pl->getplayer()==2)
      return(0);
  }
  return(0);
}

void KvirusView::newGame(){
  QPixmap rpix;
  QPixmap bpix;
  QPixmap gpix;

  this->resize(this->width(), this->height());
  setGameFlag(1);
  setHumanTurn(1);
  QPainter p;
  if(!gpix.load(icondir+"/virus_gray.xpm"))
    gpix.load("virus_gray.xpm");
  p.begin(this);
  p.fillRect(0, 0, this->width(), this->height(), gray);
  p.end();
  for(int i=0;i<9; i++){
    for(int j=0;j<9;j++){
      b->setSpot(i, j, 0);
      drawCircle(i, j, gpix);
    }
  }
  b->setSpot(0, 0, 1);
  b->setSpot(8, 8, 1);
  b->setSpot(8, 0, 2);
  b->setSpot(0, 8, 2);

  if(isBlockFlag()){
    b->setSpot(3,3, 3);
    b->setSpot(5,5, 3);
    b->setSpot(6,2, 3);
    b->setSpot(2,6, 3);
  }
  this->update();
}

void KvirusView::setBlockFlag(int flag){
  this->blockflag=flag;
}

int KvirusView::isBlockFlag(){
  return(blockflag);
}

int KvirusView::isClicked(){
  return(clickflag);
}

void KvirusView::setClicked(int flag){
  clickflag=flag;
}

int KvirusView::isHumanTurn(){
  return(moveflag);
}

void KvirusView::setHumanTurn(int flag){
  moveflag=flag;
}

void KvirusView::setGameFlag(int flag){
  gameflag=flag;
}

int KvirusView::isGameOver(){
  return gameflag;
}















































































