/***************************************************************************
                          kvirusview.h  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 00:50:22 PDT 1999
                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef KVIRUSVIEW_H 
#define KVIRUSVIEW_H 

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include <kapp.h>
#include <kmsgbox.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qbrush.h>
#include <qpixmap.h>
#include <qtimer.h>

#include "kvirusdoc.h"
/**
  * This class provides an incomplete base for your application view. 
   */


class KvirusView : public QWidget
{
  Q_OBJECT

 public:
  /** Constructor for the main view */
  KvirusView(KApplication* a=0,KvirusDoc* doc=0,QWidget *parent = 0);
  /** Destructor for the main view */
  ~KvirusView();

  Board *b;
  Player *human;
  Player *computer;

  short menuheight;
  int window_width;
  int window_height;
  int small_width;
  int small_width_y;
  int stone_width;
  int stone_height;
  int hole_begin;

  void drawCircle(int, int, QPixmap);
  void mousePressEvent(QMouseEvent *);
  void paintEvent(QPaintEvent *);
  void initBoard();
  void resizeEvent(QResizeEvent *);

  QTimer *timer;
  int gameflag;
  int clickflag;
  int moveflag;
  int blockflag;

  float score;
  void score_report();
  void drawPix(int, int, int);
  bool playerMove(Player *);
  void newGame();

  void setBlockFlag(int);
  int isBlockFlag();

  int isClicked();
  void setClicked(int);
  int isHumanTurn();
  void setHumanTurn(int);
  void setGameFlag(int);
  int isGameOver();


  KvirusDoc *doc;

 public slots:
  void computerMove();
  void eat_enemy(Player *);

 private:

};

#endif // KVIRUSVIEW_H 




































